/*
 *	rndarg.c
 *	Paul Balyoz <pab@rainbow.cse.nau.edu>
 *
 *	Output all command-line arguments passed in, but in a random order.
 *	No more than 256 arguments can be handled by this program.
 *	Requires the rnd() universal function, see rnd.c source.
 */

/*#define DEBUG			/* uncomment for debugging output */

#define MAXARGS		256	/* must be power of 2 */

main (argc,argv)
int argc;
char *argv[];
{
	int i, pos;
	char *argp[MAXARGS], *tmpp;

/* seed random number generator in a fairly good way */

	rnd(0);

/* initialize array of argument pointers */

	for (i=1; i<argc; i++) {
		argp[i] = argv[i];
	}

/* randomly arrange pointers to argument strings */

	for (i=1; i<argc; i++) {
		pos = rnd(argc-1)+1;
#ifdef DEBUG
		printf ("%3d swap with %d\n", i, pos);
#else
		tmpp = argp[pos];
		argp[pos] = argp[i];
		argp[i] = tmpp;
#endif !DEBUG
	}

/* now print the randomized arguments each on separate lines */

	for (i=1; i<argc; i++)
		printf ("%s\n", argp[i]);

	exit (0);
}
